#include "tabint.h"

/* Crea la tabella T di dim elementi */
void creatabint (tabint *pT, int dim)
{
  pT->V = (int *) calloc(dim+1,sizeof(int));
  if (pT->V == NULL)
  {
    fprintf(stderr,"Errore nell'allocazione della tabella!\n");
    exit(EXIT_FAILURE);
  }

  pT->dim = dim;
  pT->n = 0;
}

/* Distrugge la tabella T */
void distruggetabint (tabint *pT)
{
  free(pT->V);
  pT->V = NULL;
  pT->dim = 0;
  pT->n = 0;
}

/* Restituisce la cardinalita' corrente della tabella T */
int cardtabint (tabint *pT)
{
  return pT->n;
}

/* Inserisce in fondo alla tabella T l'elemento u */
void instabint (tabint *pT, int u)
{
  if (pT->n >= pT->dim)
  {
    fprintf(stderr,"Tabella piena (%d elementi)!\n",pT->dim);
    exit(EXIT_FAILURE);
  }

  pT->n++;
  pT->V[pT->n] = u;
}

/* Cancella dalla tabella T l'elemento di indice i */
void canctabint (tabint *pT, int i)
{
  if ( (i <= 0) || (i > pT->n) )
  {
    fprintf(stderr,"L'indice %d e' esterno alla tabella!\n",i);
    exit(EXIT_FAILURE);
  }
  pT->V[i] = pT->V[pT->n];
  (pT->n)--;
}

/* Stampa la tabella T */
void stampatabint (tabint *pT)
{
  int i;

  for (i = 1; i <= pT->n; i++)
    printf("%d ",pT->V[i]);
  printf("\n");
}
